//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Taskbar_H
#define Moochos_Moa_Taskbar_H
//---------------------------------------------------------------------------
// Taskbar.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Taskbar {
//---------------------------------------------------------------------------
class ETaskbarError : public Exception
{
public:
	__fastcall ETaskbarError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TNotificationIcon : public TObject
{
public:
	typedef void __fastcall (__closure * TMessageEvent)(TObject* ASender, UINT AKind);
private:
	static const UINT WM_NOTIFICATIONICON;
	static const UINT WM_TASKBARCREATED;
	HWND FHandle;
	int FIdentifier;
	TIcon* FIcon;
	int FIconIndex;
	AnsiString FHint;
	bool FShowHint;
	bool FVisible;
	TMessageEvent FOnMessage;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall Update(DWORD AKind);
	void __fastcall WndProc(TMessage& AMessage);
	void __fastcall WMNotificationIcon(TMessage& AMessage);
	void __fastcall WMTaskbarCreated(TMessage& AMessage);
	void __fastcall IconChange(TObject* ASender);
	void __fastcall DoMessage(UINT AKind);
	void __fastcall SetHint(const AnsiString& AHint);
	void __fastcall SetShowHint(bool AShowHint);
	void __fastcall SetVisible(bool AVisible);
protected:
public:
	__fastcall TNotificationIcon(int AIdentifier);
	virtual __fastcall ~TNotificationIcon();
	__property HWND Handle = {read=FHandle};
	__property int Identifier = {read=FIdentifier};
	__property TIcon* Icon = {read=FIcon};
	__property AnsiString Hint = {read=FHint, write=SetHint};
	__property bool ShowHint = {read=FShowHint, write=SetShowHint};
	__property bool Visible = {read=FVisible, write=SetVisible};
	__property TMessageEvent OnMessage = {read=FOnMessage, write=FOnMessage};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Taskbar
using namespace Moochos::Moa::Taskbar;
//---------------------------------------------------------------------------
#endif

