//---------------------------------------------------------------------------
// OptionsDialogUnit.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "OptionsDialogUnit.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOptionsDialog* OptionsDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Button93Click(TObject* ASender)
{
	Apply();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::CheckBox11Click(TObject* ASender)
{
	UpdateAccess();
	Modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::CheckBox12Click(TObject* ASender)
{
	Modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::CheckBox13Click(TObject* ASender)
{
	Modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::CheckBox21Click(TObject* ASender)
{
	UpdateAccess();
	Modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Apply()
{
	BackUp();
	Modified = false;
	DoApply();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Reset()
{
	Value = Value;
	Modified = false;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::BackUp()
{
	FBackup = Value;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Restore()
{
	Value = FBackup;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::UpdateAccess()
{
	CheckBox12->Enabled = CheckBox11->Checked;
	CheckBox13->Enabled = CheckBox11->Checked;
	Label21->Enabled = !CheckBox21->Checked;
	Button93->Enabled = Modified && OnApply != NULL;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::DoApply()
{
	if(OnApply != NULL) {
		OnApply(this);
	}
}
//---------------------------------------------------------------------------
TSettings __fastcall TOptionsDialog::GetValue()
{
	TSettings value;
	value.MouseWheel.Enabled = CheckBox11->Checked;
	value.MouseWheel.Focus = CheckBox12->Checked;
	value.MouseWheel.Scroll = CheckBox13->Checked;
	value.View.DisplayIcon = CheckBox21->Checked;
	return value;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetValue(const TSettings& AValue)
{
	CheckBox11->Checked = AValue.MouseWheel.Enabled;
	CheckBox12->Checked = AValue.MouseWheel.Focus;
	CheckBox13->Checked = AValue.MouseWheel.Scroll;
	CheckBox21->Checked = AValue.View.DisplayIcon;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetModified(bool AModified)
{
	if((AModified ? 1 : 0) == (Modified ? 1 : 0)) {
		return;
	}
	FModified = AModified;
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetOnApply(TNotifyEvent AOnApply)
{
	if(AOnApply == FOnApply) {
		return;
	}
	FOnApply = AOnApply;
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::DoShow()
{
	::ShowWindow(Application->Handle, SW_HIDE); // Do not show the main form on the taskbar
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::DoHide()
{
	ActiveControl = NULL;
}
//---------------------------------------------------------------------------
__fastcall TOptionsDialog::TOptionsDialog(TComponent* AOwner) :
	TForm(AOwner),
	FBackup(),
	FModified(false),
	FOnApply(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TOptionsDialog::~TOptionsDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TOptionsDialog::Execute()
{
	Reset();
	BackUp();
	if(ShowModal() != Button91->ModalResult) {
		Restore();
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------

