//---------------------------------------------------------------------------
#ifndef Moochos_WheelHere_Wheeler_WheelCommand_H
#define Moochos_WheelHere_Wheeler_WheelCommand_H
//---------------------------------------------------------------------------
// WheelCommand.h
//
// Version: 1.0.1
// Author: Moochos
//---------------------------------------------------------------------------
#include "ScrollSnap.h"
#include "SystemSnap.h"
#include "WheelCommon.h"
#include "WindowSnap.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace WheelHere { namespace Wheeler { namespace WheelCommand {
//---------------------------------------------------------------------------
class TWheelCommand
{
private:
	MSG& FMessage;
	TWindowSnap FWindowSnap;
	TScrollSnap FScrollSnap;
	TSystemSnap FSystemSnap;
	bool FFocus;
	bool FScroll;
	TWheelCommand(const TWheelCommand& AOther); // Forbidden
	TWheelCommand& operator =(const TWheelCommand& AOther); // Forbidden
	bool ValidateMessage();
	void PerformFocus();
	void PerformScroll();
	bool AttemptScroll();
	bool EmulateScroll();
	bool EmulateScrollTo(bool AControl);
	void ClearMessage();
protected:
public:
	TWheelCommand(MSG& AMessage);
	~TWheelCommand();
	void Execute();
	__property bool Focus = {read=FFocus, write=FFocus};
	__property bool Scroll = {read=FScroll, write=FScroll};
};
//---------------------------------------------------------------------------
}}}} // End of namespace Moochos::WheelHere::Wheeler::WheelCommand
using namespace Moochos::WheelHere::Wheeler::WheelCommand;
//---------------------------------------------------------------------------
#endif

